package com.maryanovsky.gwtutils.client;

import java.util.Iterator;
import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.ui.ComplexPanel;
import com.google.gwt.user.client.ui.FlowPanel;
import com.google.gwt.user.client.ui.InsertPanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * Provides functionality equivalent to {@link FlowPanel}, but wraps a span
 * element instead of a div.
 * 
 * @author Maryanovsky Alexander
 */
public class InlineFlowPanel extends ComplexPanel implements InsertPanel {

    /**
	 * Creates a new {@link InlineFlowPanel}.
	 */
    public InlineFlowPanel() {
        setElement(DOM.createSpan());
    }

    /**
	 * Adds a widget to the panel.
	 */
    public void add(Widget widget) {
        add(widget, getElement());
    }

    /**
	 * Inserts a widget at the specified index.
	 */
    public void insert(Widget widget, int index) {
        insert(widget, getElement(), index, true);
    }

    /**
	 * Removes all widgets from the panel.
	 */
    public void clear() {
        Iterator<Widget> a = iterator();
        while (a.hasNext()) a.remove();
    }
}
