package com.maryanovsky.gwtutils.client.event;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

/**
 * A convenience class for managing {@linkplain ChangeListener}s.
 * 
 * @author Maryanovsky Alexander
 */
public class ChangeListenerList {

    /***/
    private final List<ChangeListener> a = new LinkedList<ChangeListener>();

    /**
	 * Adds the specified <code>ChangeListener</code> to the list.
	 */
    public void add(ChangeListener listener) {
        a.add(listener);
    }

    /**
	 * Removes the specified <code>ChangeListener</code> to the list.
	 */
    public void remove(ChangeListener listener) {
        a.remove(listener);
    }

    /**
	 * Notifies all registered <code>ChangeListener</code>s of a change in the
	 * specified source object.
	 */
    public void fireStateChanged(Object source) {
        ChangeEvent b = new ChangeEvent(source);
        List<ChangeListener> c = new ArrayList<ChangeListener>(a);
        for (ChangeListener d : c) d.stateChanged(b);
    }
}
