package com.maryanovsky.gwtutils.client.event;

/**
 * The interface for classes which are capable of notifying registered listeners
 * of some change occurring in them.
 * 
 * @author Maryanovsky Alexander
 */
public interface HasChange {

    /**
	 * Adds the specified <code>ChangeListener</code> to receive notifications
	 * when the object changes in some manner.
	 */
    void addChangeListener(ChangeListener listener);

    /**
	 * Removes the specified <code>ChangeListener</code> from receiving
	 * notifications when the object changes in some manner.
	 */
    void removeChangeListener(ChangeListener listener);
}
