package com.maryanovsky.gwtutils.client.event;

import com.google.gwt.event.shared.HandlerRegistration;

/**
 * An implementation of {@link HandlerRegistration} which holds a collection of
 * registrations and invokes their {@link HandlerRegistration#removeHandler()}
 * method when its own method is invoked.
 * 
 * @author Maryanovsky Alexander
 */
public class MultipleHandlerRegistration implements HandlerRegistration {

    /***/
    private HandlerRegistration[] a;

    /**
	 * Creates a new {@link MultipleHandlerRegistration} with the specified
	 * registrations.
	 */
    public MultipleHandlerRegistration(HandlerRegistration... registrations) {
        if (registrations == null) throw new IllegalArgumentException("registrations may not be null");
        this.a = registrations;
    }

    /**
	 * Invokes {@link HandlerRegistration#removeHandler()} on all the
	 * registrations.
	 */
    public void removeHandler() {
        for (HandlerRegistration b : a) b.removeHandler();
        a = null;
    }
}
