package com.maryanovsky.gwtutils.client.event;

import java.util.EventObject;

/**
 * Encapsulates a change event in some named property.
 * 
 * @author Maryanovsky Alexander
 */
public class PropertyChangeEvent extends EventObject {

    /***/
    private final String a;

    /***/
    private final Object b;

    /***/
    private final Object c;

    /**
	 * Creates a new <code>PropertyChangeEvent</code> with the specified source
	 * object, name of the property that changed and the old and new values of
	 * the property.
	 */
    public PropertyChangeEvent(Object source, String propertyName, Object oldValue, Object newValue) {
        super(source);
        if (propertyName == null) throw new IllegalArgumentException("propertyName may not be null");
        this.a = propertyName;
        this.b = oldValue;
        this.c = newValue;
    }

    /**
	 * Returns the name of the property that changed.
	 */
    public String getPropertyName() {
        return a;
    }

    /**
	 * Returns the old value of the property.
	 */
    public Object getOldValue() {
        return b;
    }

    /**
	 * Returns the new value of the property.
	 */
    public Object getNewValue() {
        return c;
    }
}
