package com.maryanovsky.gwtutils.client.event;

import java.util.EventListener;

/**
 * A listener which is notified when an entity changes between ready and unready
 * states.
 * 
 * @author Maryanovsky Alexander
 */
public interface ReadyListener<T> extends EventListener {

    /**
	 * Invoked when the entity becomes ready.
	 */
    void becameReady(T source);

    /**
	 * Invoked when the entity becomes unready.
	 */
    void becameUnready(T source);
}
