package com.maryanovsky.gwtutils.client.geom;

/**
 * Provides a view of {@linkplain Size} without allowing modifications.
 * 
 * @author Maryanovsky Alexander
 */
public interface SizeView {

    /**
	 * Returns the width.
	 */
    int getWidth();

    /**
	 * Returns the height.
	 */
    int getHeight();

    /**
	 * Returns <code>true</code> if either the width or height are
	 * <code>0</code>.
	 */
    boolean isEmpty();
}
