package com.maryanovsky.gwtutils.client.net;

import com.google.gwt.http.client.RequestException;

/**
 * A common interface for builders of requests.
 * 
 * @author Maryanovsky Alexander
 */
public interface RequestMaker<T> {

    /**
	 * Sends the request. The response will be delivered to the specified
	 * callback. 
	 */
    public void sendRequest(ResultCallback<T> callback) throws RequestException;

    /**
	 * Returns the URL of the requested resource.
	 */
    public String getUrl();
}
