package com.maryanovsky.gwtutils.client.net;

import com.google.gwt.xml.client.Document;
import com.maryanovsky.gwtutils.client.text.ParseException;

/**
 * An interface for classes which can parse XML documents, converting them into
 * an object.
 *
 * @author Maryanovsky Alexander
 */
public interface XmlParser<T> {

    /**
	 * Parses the specified XML document, returning the resulting object. Throws
	 * a {@link ParseException} if unable to parse.
	 */
    T parse(Document document) throws ParseException;
}
