package com.maryanovsky.gwtutils.client.ui;

import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.user.client.ui.DockLayoutPanel;
import com.google.gwt.user.client.ui.Widget;

/**
 * A {@link DockLayoutPanel} which allows the sizes of the widgets to be
 * adjusted after they are added.
 * 
 * @author Maryanovsky Alexander
 */
public class AdjustableDockLayoutPanel extends DockLayoutPanel {

    /**
	 * Creates a new {@link AdjustableDockLayoutPanel} with the specified CSS
	 * unit in which sizes will be specified.
	 */
    public AdjustableDockLayoutPanel(Unit unit) {
        super(unit);
    }

    /**
	 * Sets the size of the specified widget.
	 */
    public void setWidgetSize(Widget widget, double size, int animationLength) {
        LayoutData a = (LayoutData) widget.getLayoutData();
        if (size == a.size) return;
        a.size = size;
        animate(animationLength);
    }
}
