package com.maryanovsky.gwtutils.client.ui;

import com.google.gwt.dom.client.Style.Unit;

/**
 * Encapsulates a CSS length, that is a value and the CSS unit of this value
 * ("2em", "5px" etc).
 * 
 * @author Maryanovsky Alexander
 */
public class CssLength {

    /***/
    private final double a;

    /***/
    private final Unit b;

    /**
	 * Creates a new <code>CssLength</code> object with the specified value and
	 * CSS unit.
	 */
    public CssLength(double value, Unit unit) {
        if (unit == null) throw new IllegalArgumentException("unit may not be null");
        this.a = value;
        this.b = unit;
    }

    /**
	 * Returns the value.
	 */
    public double getValue() {
        return a;
    }

    /**
	 * Returns the CSS unit.
	 */
    public Unit getUnit() {
        return b;
    }

    /**
	 * Returns the value with the name of the unit appended to it.
	 */
    public String toString() {
        return a + b.getType();
    }
}
