package com.maryanovsky.gwtutils.client.ui;

import java.util.Iterator;
import com.google.gwt.user.client.ui.DeckPanel;
import com.google.gwt.user.client.ui.ProvidesResize;
import com.google.gwt.user.client.ui.RequiresResize;
import com.google.gwt.user.client.ui.Widget;

/**
 * A {@link DeckPanel} which also implements {@link RequiresResize} and
 * {@link ProvidesResize}.
 * 
 * @author Maryanovsky Alexander
 */
public class DeckLayoutPanel extends DeckPanel implements RequiresResize, ProvidesResize {

    /**
	 * Invokes {@link RequiresResize#onResize()} on all children that implement
	 * {@link RequiresResize}. 
	 */
    public void onResize() {
        for (Iterator<Widget> a = iterator(); a.hasNext(); ) {
            Widget b = a.next();
            if (b instanceof RequiresResize) ((RequiresResize) b).onResize();
        }
    }
}
