package com.maryanovsky.gwtutils.client.ui;

import com.google.gwt.user.client.ui.Composite;

/**
 * Emulates a real dialog by using a callback which is invoked when the dialog's
 * operation is done.
 *
 * @author Maryanovsky Alexander
 */
public class Dialog extends Composite {

    /**
	 * The callback.
	 */
    protected final DialogCallback dialogCallback;

    /**
	 * Creates a new <code>Dialog</code> with the specified callback.
	 */
    public Dialog(DialogCallback dialogCallback) {
        if (dialogCallback == null) throw new IllegalArgumentException("dialogCallback may not be null");
        this.dialogCallback = dialogCallback;
    }
}
