package com.maryanovsky.gwtutils.client.ui;

/**
 * The callback interface for dialogs.
 *
 * @author Maryanovsky Alexander
 */
public interface DialogCallback {

    /**
	 * Invoked when the user confirmed whatever it is the dialog asked him.
	 * This is usually invoked when the user presses the equivalent of the "OK"
	 * button.
	 * 
	 * @param result The result of the dialog.
	 */
    void confirmed(Object result);

    /**
	 * Invoked when the user denied whatever it is the dialog asked him.
	 * This is usually invoked when the user presses the equivalent of the
	 * "Cancel" button.
	 */
    void denied();
}
