package com.maryanovsky.gwtutils.client.ui;

import java.util.EventListener;

/**
 * The interface for getting notified when an image finishes loading.
 * 
 * @author Maryanovsky Alexander
 */
public interface ImageLoadListener extends EventListener {

    /**
	 * Invoked when the image finishes loading successfully.
	 * 
	 * @param url The url of the image
	 * @param width The width of the image.
	 * @param height The height of the image.
	 */
    void imageLoaded(String url, int width, int height);

    /**
	 * Invoked when the image failed loading.
	 */
    void imageFailed(String url);
}
