package com.maryanovsky.gwtutils.client.ui;

import com.google.gwt.core.client.Scheduler;
import com.google.gwt.core.client.Scheduler.ScheduledCommand;
import com.google.gwt.uibinder.client.UiConstructor;
import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.ui.Widget;

/**
 * A small hack which allows one to pass size information from a UiBinder 
 * ui.xml file to the code that does the actual layout. To do this, you add a
 * {@link UiBinderLayoutSize} into the layout in the ui.xml file with a
 * corresponding "ui:field" attribute, then access it from the layout code. It
 * removes itself from the container hierarchy as soon as it's attached.
 * 
 * @author Maryanovsky Alexander
 */
public class UiBinderLayoutSize extends Widget {

    /***/
    private double a = -1;

    /***/
    private double b = -1;

    /**
	 * Creates a new {@link UiBinderLayoutSize}.
	 */
    @UiConstructor
    public UiBinderLayoutSize() {
        setElement(DOM.createSpan());
    }

    /**
	 * Sets the width.
	 */
    public void setWidth(String width) {
        this.a = Double.parseDouble(width);
    }

    /**
	 * Sets the height.
	 */
    public void setHeight(String height) {
        this.b = Double.parseDouble(height);
    }

    /**
	 * Returns the width.
	 */
    public double getWidth() {
        return a;
    }

    /**
	 * Returns the height.
	 */
    public double getHeight() {
        return b;
    }

    /**
	 * Remove ourselves from the container hierarchy.
	 */
    public void onLoad() {
        Scheduler.get().scheduleDeferred(new ScheduledCommand() {

            public void execute() {
                removeFromParent();
            }
        });
    }
}
