package com.maryanovsky.gwtutils.client.ui.mouse.gestures;

import com.google.gwt.event.dom.client.MouseEvent;
import com.google.gwt.event.shared.EventHandler;
import com.maryanovsky.gwtutils.client.event.SyntheticEvent;

/**
 * The base class for all gesture events which are synthesized from mouse
 * events.
 * 
 * @author Maryanovsky Alexander
 */
public abstract class SyntheticMouseGestureEvent<H extends EventHandler, E extends MouseEvent<? extends EventHandler>> extends SyntheticEvent<H, E> {

    /**
	 * Creates a new {@link SyntheticMouseGestureEvent} with the specified
	 * source mouse event from which it was synthesized.
	 */
    protected SyntheticMouseGestureEvent(E sourceEvent) {
        super(sourceEvent);
    }
}
