package com.maryanovsky.gwtutils.client.ui.mouse.gestures.drag;

import com.google.gwt.event.dom.client.MouseUpEvent;
import com.maryanovsky.gwtutils.client.ui.mouse.gestures.SyntheticMouseGestureEvent;

/**
 * Represents a drag cancel event. A drag event may be cancelled if after the
 * initial mouse-down, the mouse is not actually moved.
 * 
 * @author Maryanovsky Alexander
 */
public class DragCancelEvent extends SyntheticMouseGestureEvent<DragCancelHandler, MouseUpEvent> {

    /***/
    private static final Type<DragCancelHandler> a = new Type<DragCancelHandler>();

    /**
	 * Creates a new {@link DragCancelEvent} from the specified source
	 * {@link MouseUpEvent}.
	 * 
	 * @param evt The mouse up event that triggered this event.
	 */
    public DragCancelEvent(MouseUpEvent evt) {
        super(evt);
    }

    /**
	 * Returns the event type associated with drag cancel events.
	 */
    public static Type<DragCancelHandler> getType() {
        return a;
    }

    /**
	 * Returns the event type associated with drag cancel events.
	 */
    public Type<DragCancelHandler> getAssociatedType() {
        return a;
    }

    /**
	 * Dispatches the event to the handler.
	 */
    protected void dispatch(DragCancelHandler handler) {
        handler.onDragCancel(this);
    }
}
