package com.maryanovsky.gwtutils.client.ui.mouse.gestures.drag;

import com.google.gwt.event.shared.HandlerRegistration;
import com.maryanovsky.gwtutils.client.event.MultipleHandlerRegistration;

/**
 * Receiver used to handle all drag events.
 * 
 * @author Maryanovsky Alexander
 */
public abstract class HandlesAllDragEvents implements DragStartHandler, DragMoveHandler, DragEndHandler, DragCancelHandler {

    /**
	 * Convenience method to handle all drag events from a source.
	 */
    public HandlerRegistration handle(HasAllDragHandlers source) {
        return handle(source, this);
    }

    /**
	 * Convenience method to handle all drag events from a source.
	 */
    public static <H extends DragStartHandler & DragMoveHandler & DragEndHandler & DragCancelHandler> HandlerRegistration handle(HasAllDragHandlers source, H receiver) {
        return new MultipleHandlerRegistration(source.addDragStartHandler(receiver), source.addDragMoveHandler(receiver), source.addDragEndHandler(receiver), source.addDragCancelHandler(receiver));
    }
}
