package com.maryanovsky.gwtutils.client.ui.mouse.gestures.wheelscroll;

import com.google.gwt.event.shared.HandlerRegistration;
import com.maryanovsky.gwtutils.client.event.MultipleHandlerRegistration;

/**
 * Receiver used to handle all mouse wheel scroll events.
 * 
 * @author Maryanovsky Alexander
 */
public abstract class HandlesAllWheelScrollEvents implements WheelScrollUpHandler, WheelScrollDownHandler {

    /**
	 * Convenience method to handle all mouse wheel scroll events from a source.
	 */
    public HandlerRegistration handle(HasAllWheelScrollHandlers source) {
        return handle(source, this);
    }

    /**
	 * Convenience method to handle all mouse wheel scroll events from a source.
	 */
    public static <H extends WheelScrollUpHandler & WheelScrollDownHandler> HandlerRegistration handle(HasAllWheelScrollHandlers source, H receiver) {
        return new MultipleHandlerRegistration(source.addWheelScrollUpHandler(receiver), source.addWheelScrollDownHandler(receiver));
    }
}
