package com.maryanovsky.gwtutils.client.ui.touch.gestures;

import com.google.gwt.event.dom.client.TouchEvent;
import com.google.gwt.event.shared.EventHandler;
import com.maryanovsky.gwtutils.client.event.SyntheticEvent;

/**
 * The base class for all gesture events which are synthesized from touch
 * events.
 * 
 * @author Maryanovsky Alexander
 */
public abstract class SyntheticTouchGestureEvent<H extends EventHandler, E extends TouchEvent<? extends EventHandler>> extends SyntheticEvent<H, E> {

    /**
	 * Creates a new {@link SyntheticTouchGestureEvent} with the specified
	 * source touch event from which it was synthesized.
	 */
    protected SyntheticTouchGestureEvent(E sourceEvent) {
        super(sourceEvent);
    }
}
