package com.maryanovsky.gwtutils.client.ui.touch.gestures.buttontap;

import com.google.gwt.event.dom.client.TouchEndEvent;
import com.maryanovsky.gwtutils.client.ui.touch.gestures.SyntheticTouchGestureEvent;

/**
 * Represents a button-tap event.
 * 
 * @author Maryanovsky Alexander
 */
public class ButtonTapEvent extends SyntheticTouchGestureEvent<ButtonTapHandler, TouchEndEvent> {

    /***/
    private static final Type<ButtonTapHandler> a = new Type<ButtonTapHandler>();

    /**
	 * Creates a new {@link ButtonTapEvent} from the specified source
	 * {@link TouchEndEvent}.
	 * 
	 * @param evt The touch end event that triggered this event.
	 */
    public ButtonTapEvent(TouchEndEvent evt) {
        super(evt);
    }

    /**
	 * Returns the event type associated with button-tap events.
	 */
    public static Type<ButtonTapHandler> getType() {
        return a;
    }

    /**
	 * Returns the event type associated with button-tap events.
	 */
    public Type<ButtonTapHandler> getAssociatedType() {
        return a;
    }

    /**
	 * Dispatches the event to the handler.
	 */
    protected void dispatch(ButtonTapHandler handler) {
        handler.onButtonTap(this);
    }
}
