package com.maryanovsky.gwtutils.client.ui.touch.gestures.drag;

import com.google.gwt.event.dom.client.TouchEvent;
import com.google.gwt.event.shared.EventHandler;
import com.maryanovsky.gwtutils.client.ui.touch.gestures.SyntheticTouchGestureEvent;

/**
 * Represents a drag cancel event.
 * 
 * @author Maryanovsky Alexander
 */
public class DragCancelEvent extends SyntheticTouchGestureEvent<DragCancelHandler, TouchEvent<? extends EventHandler>> {

    /***/
    private static final Type<DragCancelHandler> a = new Type<DragCancelHandler>();

    /**
	 * Creates a new {@link DragCancelEvent} from the specified source
	 * {@link TouchEvent}.
	 * 
	 * @param evt The touch event that triggered this event.
	 */
    public DragCancelEvent(TouchEvent<? extends EventHandler> evt) {
        super(evt);
    }

    /**
	 * Returns the event type associated with drag cancel events.
	 */
    public static Type<DragCancelHandler> getType() {
        return a;
    }

    /**
	 * Returns the event type associated with drag cancel events.
	 */
    public Type<DragCancelHandler> getAssociatedType() {
        return a;
    }

    /**
	 * Dispatches the event to the handler.
	 */
    protected void dispatch(DragCancelHandler handler) {
        handler.onDragCancel(this);
    }
}
