package com.maryanovsky.gwtutils.client.ui.touch.gestures.pinch;

import com.google.gwt.event.shared.HandlerRegistration;
import com.maryanovsky.gwtutils.client.event.MultipleHandlerRegistration;

/**
 * Receiver used to handle all pinch events.
 * 
 * @author Maryanovsky Alexander
 */
public abstract class HandlesAllPinchEvents implements PinchStartHandler, PinchChangeHandler, PinchEndHandler, PinchCancelHandler {

    /**
	 * Convenience method to handle all pinch events from a source.
	 */
    public HandlerRegistration handle(HasAllPinchHandlers source) {
        return handle(source, this);
    }

    /**
	 * Convenience method to handle all pinch events from a source.
	 */
    public static <H extends PinchStartHandler & PinchChangeHandler & PinchEndHandler & PinchCancelHandler> HandlerRegistration handle(HasAllPinchHandlers source, H receiver) {
        return new MultipleHandlerRegistration(source.addPinchStartHandler(receiver), source.addPinchChangeHandler(receiver), source.addPinchEndHandler(receiver), source.addPinchCancelHandler(receiver));
    }
}
