package com.maryanovsky.gwtutils.client.ui.touch.gestures.pinch;

import com.google.gwt.event.dom.client.TouchEvent;
import com.google.gwt.event.shared.EventHandler;
import com.maryanovsky.gwtutils.client.ui.touch.gestures.SyntheticTouchGestureEvent;

/**
 * Represents a pinch cancel event.
 * 
 * @author Maryanovsky Alexander
 */
public class PinchCancelEvent extends SyntheticTouchGestureEvent<PinchCancelHandler, TouchEvent<? extends EventHandler>> {

    /***/
    private static final Type<PinchCancelHandler> a = new Type<PinchCancelHandler>();

    /**
	 * Creates a new {@link PinchCancelEvent} from the specified source
	 * {@link TouchEvent}.
	 * 
	 * @param evt The touch event that triggered this event.
	 */
    public PinchCancelEvent(TouchEvent<? extends EventHandler> evt) {
        super(evt);
    }

    /**
	 * Returns the event type associated with pinch cancel events.
	 */
    public static Type<PinchCancelHandler> getType() {
        return a;
    }

    /**
	 * Returns the event type associated with pinch cancel events.
	 */
    public Type<PinchCancelHandler> getAssociatedType() {
        return a;
    }

    /**
	 * Dispatches the event to the handler.
	 */
    protected void dispatch(PinchCancelHandler handler) {
        handler.onPinchCancel(this);
    }
}
