package com.maryanovsky.map.client;

import com.maryanovsky.gwtutils.client.geom.SizeView;

/**
 * Defines the conversion from pixel map coordinates to the map tiles displayed
 * on the map. 
 * 
 * @author Maryanovsky Alexander
 */
public interface TileLayer {

    /**
	 * Returns the size of the tiles. 
	 */
    SizeView getTileSize();

    /**
	 * Returns the tile to display at the specified location (in pixels,
	 * relative to the top-left of the map) and zoom. Returns <code>null</code>
	 * if there is no tile at the specified location, if, for example, it is
	 * outside the boundaries of the map.
	 */
    Tile getTile(int x, int y, int zoom);

    /**
	 * Releases any resources associated with the specified tile that was
	 * returned by {@link #getTile(int, int, int)}.
	 */
    void releaseTile(Tile tile);
}
