package com.maryanovsky.map.client.opengis.wms;

import com.maryanovsky.gwtutils.client.geom.DoublePointView;
import com.maryanovsky.map.client.Projection;

/**
 * A {@link WmsProjection} adds the ability to convert from pixel coordinates to
 * the projection's "native" coordinates. The "native" coordinates are the ones
 * specified in a <code>GetMap</code> request. 
 * 
 * @author Maryanovsky Alexander
 */
public interface WmsProjection extends Projection {

    /**
	 * Converts the specified pixel coordinates to the "native" coordinates of
	 * the projection. Unlike
	 * {@link Projection#fromPixelToLatLng(com.maryanovsky.gwtutils.client.geom.PointView, int)}
	 * this method should return <code>null</code> if the specified location is
	 * outside the map. 
	 */
    public DoublePointView fromPixelToNative(int x, int y, int zoom);
}
