package com.maryanovsky.map.client.osm;

import com.maryanovsky.gwtutils.client.geom.Size;
import com.maryanovsky.map.client.projections.FixedCoefZoomStrategy;
import com.maryanovsky.map.client.projections.MercatorProjection;

/**
 * Implements the projection used by OpenStreetMaps.org, which is a variant of
 * the mercator projection.
 * 
 * @author Maryanovsky Alexander
 */
public class OsmMercatorProjection extends MercatorProjection {

    /**
	 * The sole instance.
	 */
    public static final OsmMercatorProjection INSTANCE = new OsmMercatorProjection();

    /**
	 * Creates a new {@link OsmMercatorProjection}.
	 */
    public OsmMercatorProjection() {
        super(FixedCoefZoomStrategy.getInstance(2), 0, new Size(256, 256), true, 0, Math.PI);
    }
}
