package com.maryanovsky.map.client.projections;

import com.maryanovsky.map.client.Projection;

/**
 * An interface that encapsulates the zoom magnification part of a
 * {@link Projection}. Implementation can provide various ways of specifying
 * the zoom magnification between two zooms. 
 * 
 * @author Maryanovsky Alexander
 */
public interface ZoomStrategy {

    /**
	 * See {@link Projection#getZoomMagnification(int, int)} for the contract
	 * of this method.
	 */
    double getZoomMagnification(int startZoom, int endZoom);
}
