package com.maryanovsky.map.client.tiles;

import com.google.gwt.event.dom.client.ErrorEvent;
import com.google.gwt.event.dom.client.ErrorHandler;
import com.google.gwt.event.dom.client.LoadEvent;
import com.google.gwt.event.dom.client.LoadHandler;
import com.maryanovsky.gwtutils.client.ui.UiUtils;

/**
 * The default {@linkplain ImageTile} implementation.
 * 
 * @author Maryanovsky Alexander
 */
final class DefaultImageTile extends ImageTile {

    /***/
    private boolean a = false;

    /***/
    private final LoadHandler b = new LoadHandler() {

        public void onLoad(LoadEvent evt) {
            if (a) return;
            if (tileSize == null) setImageSize("auto"); else UiUtils.setSize(image, tileSize);
            markReady();
        }
    };

    /***/
    private final ErrorHandler c = new ErrorHandler() {

        public void onError(ErrorEvent evt) {
            if (!a) markReady();
        }
    };

    /**
	 * Creates a new <code>DefaultTile</code> with the specified image url.
	 */
    public DefaultImageTile(String url) {
        super(url);
        image.addLoadHandler(b);
        image.addErrorHandler(c);
        setImageSize("0px");
    }

    /**
	 * {@inheritDoc}
	 */
    public void startLoading() {
        a = false;
        markUnready();
        image.setUrl(url);
    }

    /**
	 * {@inheritDoc} 
	 */
    public void cancelLoading() {
        if (!isReady()) {
            a = true;
            image.setUrl("");
            setImageSize("0px");
        }
    }
}
