package com.maryanovsky.mapdemo.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.ui.RootPanel;
import com.maryanovsky.gwtutils.client.geom.Size;
import com.maryanovsky.gwtutils.client.geom.SizeView;
import com.maryanovsky.gwtutils.client.ui.UiUtils;
import com.maryanovsky.map.client.*;
import com.maryanovsky.map.client.actions.StandardActions;
import com.maryanovsky.map.client.osm.OsmMercatorProjection;
import com.maryanovsky.map.client.tiles.ImageTile;

public class CustomDemo implements EntryPoint {

    /**
	 * Starts the demo.
	 */
    public void onModuleLoad() {
        TileLayer a = new TileLayer() {

            public SizeView getTileSize() {
                return new Size(256, 256);
            }

            public Tile getTile(int x, int y, int zoom) {
                y /= 256;
                x /= 256;
                if ((x < 0) || (x > 13) || (y < 0) || (y > 9)) return null;
                int b = y * 14 + x;
                return ImageTile.makeImageTile("tiles/tile-" + b + ".jpg");
            }

            public void releaseTile(Tile tile) {
            }
        };
        Map b = new Map(OsmMercatorProjection.INSTANCE, a, 4, 4);
        LatLng c = new LatLng(60.050317, 30.350161);
        int d = 4;
        MapWidget e = new MapWidget(new MapLocationModel(4, 4, c, d));
        e.setMap(b);
        StandardActions.getInstance().addAll(e);
        UiUtils.addFullSize(RootPanel.get(), e);
    }
}
