package com.maryanovsky.mapdemo.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.ui.RootPanel;
import com.maryanovsky.gwtutils.client.ui.UiUtils;
import com.maryanovsky.map.client.*;
import com.maryanovsky.map.client.actions.StandardActions;
import com.maryanovsky.map.client.osm.OsmMercatorProjection;
import com.maryanovsky.map.client.osm.OsmTileLayer;

/**
 * The entry point of the tutorial demo.
 * 
 * @author Maryanovsky Alexander
 */
public class TutorialDemo implements EntryPoint {

    /**
	 * Starts the demo.
	 */
    public void onModuleLoad() {
        TileLayer a = new OsmTileLayer("http://tile.openstreetmap.org", 0, 16);
        Map b = new Map(OsmMercatorProjection.INSTANCE, a, 0, 16);
        LatLng c = new LatLng(60.050317, 30.350161);
        int d = 13;
        MapWidget e = new MapWidget(new MapLocationModel(0, 16, c, d));
        e.setMap(b);
        StandardActions.getInstance().addAll(e);
        UiUtils.addFullSize(RootPanel.get(), e);
    }
}
