package com.maryanovsky.mapdemo.client;

import java.util.List;
import com.google.gwt.http.client.RequestBuilder;
import com.google.gwt.http.client.RequestException;
import com.google.gwt.http.client.URL;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Widget;
import com.maryanovsky.gwtutils.client.net.ResultCallback;
import com.maryanovsky.map.client.LatLng;
import com.maryanovsky.map.client.Map;
import com.maryanovsky.map.client.MapLocationModel;
import com.maryanovsky.map.client.opengis.wms.Capabilities;
import com.maryanovsky.map.client.opengis.wms.Capabilities.TileSet;
import com.maryanovsky.map.client.opengis.wms.Wms;

/**
 * A demo of WMS support.
 * 
 * @author Maryanovsky Alexander
 */
public class WmsDemo extends MapDemo {

    /***/
    private Map a;

    /***/
    private MapLocationModel b;

    /**
	 * Starts the demo.
	 */
    public void onModuleLoad() {
        try {
            ResultCallback<Capabilities> d = new ResultCallback<Capabilities>() {

                public void requestFinished() {
                }

                public void errorOcurred(String errorMessage) {
                }

                public void resultReceived(Capabilities capabilities) {
                    c(capabilities);
                }
            };
            String e = Capabilities.makeGetRequestUrl("http://labs.metacarta.com/wms-c/Basic.py?");
            String f = "http://www.maryanovsky.com/sasha/maps/proxy.php?mode=native&url=" + URL.encodeQueryString(e);
            RequestBuilder g = new RequestBuilder(RequestBuilder.GET, f);
            g.sendRequest(null, new Capabilities.ResponseHandler(f, d));
        } catch (RequestException d) {
            Window.alert(d.getMessage());
        }
    }

    /***/
    private void c(Capabilities d) {
        String e = "base";
        List<TileSet> f = d.getTileSetsByLayerName(e);
        if (f.isEmpty()) {
            Window.alert("No tile sets for layer \"" + e + "\" found");
            Window.alert("Total tile sets: " + d.getTileSets().size());
            return;
        }
        TileSet g = f.get(0);
        this.a = Wms.createMap(d, g, true);
        this.b = new MapLocationModel(1, a.getMaxZoom(), new LatLng(31.5, 35), 2);
        super.onModuleLoad();
    }

    @Override
    protected Widget createCopyrightNotice() {
        return null;
    }

    @Override
    protected Map createMap() {
        return a;
    }

    @Override
    protected MapLocationModel createMapLocationModel() {
        return b;
    }
}
